Index: trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc	(revision 1340)
@@ -279,5 +279,6 @@
 					  const G4Element*  anElement)
 {
-  return IsZAApplicable(aDP, anElement->GetZ(), anElement->GetN());
+  return IsIsoApplicable(aDP, G4lrint(anElement->GetZ()),
+                              G4lrint(anElement->GetN()));
 } 
 
@@ -287,6 +288,6 @@
 
 G4bool 
-G4GlauberGribovCrossSection::IsZAApplicable(const G4DynamicParticle* aDP, 
-					    G4double Z, G4double)
+G4GlauberGribovCrossSection::IsIsoApplicable(const G4DynamicParticle* aDP, 
+					     G4int Z, G4int)
 {
   G4bool applicable      = false;
@@ -297,5 +298,5 @@
  
   if ( ( kineticEnergy  >= fLowerLimit &&
-         Z > 1.5 &&      // >=  He
+         Z > 1 &&      // >=  He
        ( theParticle == theAProton   ||
          theParticle == theGamma     ||
@@ -305,5 +306,5 @@
 
        ( kineticEnergy  >= fLowerLimit &&
-         Z > 1.5 &&      // >=  He
+         Z > 1 &&      // >=  He
        ( theParticle == theProton    ||
          theParticle == theNeutron   ||   
@@ -325,5 +326,6 @@
 GetCrossSection(const G4DynamicParticle* aParticle, const G4Element* anElement, G4double T)
 {
-  return GetIsoZACrossSection(aParticle, anElement->GetZ(), anElement->GetN(), T);
+  return GetZandACrossSection(aParticle, G4lrint(anElement->GetZ()),
+                              G4lrint(anElement->GetN()), T);
 }
 
@@ -338,5 +340,5 @@
 
 G4double G4GlauberGribovCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* aParticle, G4double Z, G4double A, G4double)
+GetZandACrossSection(const G4DynamicParticle* aParticle, G4int Z, G4int A, G4double)
 {
   G4double xsection, sigma, cofInelastic, cofTotal, nucleusSquare, ratio;
@@ -362,5 +364,5 @@
   // cofInelastic = 2.0;
 
-  if( A > 1.5 )
+  if( A > 1 )
   { 
     nucleusSquare = cofTotal*pi*R*R;   // basically 2piRR
@@ -420,5 +422,5 @@
 
 G4double G4GlauberGribovCrossSection::
-GetRatioSD(const G4DynamicParticle* aParticle, G4double A, G4double Z)
+GetRatioSD(const G4DynamicParticle* aParticle, G4int A, G4int Z)
 {
   G4double sigma, cofInelastic, cofTotal, nucleusSquare, ratio;
@@ -462,5 +464,5 @@
 
 G4double G4GlauberGribovCrossSection::
-GetRatioQE(const G4DynamicParticle* aParticle, G4double A, G4double Z)
+GetRatioQE(const G4DynamicParticle* aParticle, G4int A, G4int Z)
 {
   G4double sigma, cofInelastic, cofTotal, nucleusSquare, ratio;
@@ -510,11 +512,10 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXsc(const G4DynamicParticle* aParticle, 
-                                                  const G4Element* anElement          )
-{
-  G4double At = anElement->GetN();  // number of nucleons 
-  G4double Zt = anElement->GetZ();  // number of protons
-
-
-  return GetHadronNucleonXsc( aParticle, At, Zt );
+                                                 const G4Element* anElement)
+{
+  G4int At = G4lrint(anElement->GetN());  // number of nucleons 
+  G4int Zt = G4lrint(anElement->GetZ());  // number of protons
+
+  return GetHadronNucleonXsc(aParticle, At, Zt);
 }
 
@@ -531,11 +532,11 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXsc(const G4DynamicParticle* aParticle, 
-                                                   G4double At,  G4double Zt       )
+                                                 G4int At, G4int Zt)
 {
   G4double xsection;
 
-
   G4double targ_mass = G4ParticleTable::GetParticleTable()->
-  GetIonTable()->GetIonMass( G4int(Zt+0.5) , G4int(At+0.5) );
+  GetIonTable()->GetIonMass(Zt, At);
+//  GetIonTable()->GetIonMass( G4int(Zt+0.5) , G4int(At+0.5) );
 
   targ_mass = 0.939*GeV;  // ~mean neutron and proton ???
@@ -550,16 +551,17 @@
   const G4ParticleDefinition* theParticle = aParticle->GetDefinition();
   
+  G4double aa = At;
 
   if(theParticle == theGamma) 
   {
-    xsection = At*(0.0677*std::pow(sMand,0.0808) + 0.129*std::pow(sMand,-0.4525));
+    xsection = aa*(0.0677*std::pow(sMand,0.0808) + 0.129*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == theNeutron) // as proton ??? 
   {
-    xsection = At*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
+    xsection = aa*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == theProton) 
   {
-    xsection = At*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
+    xsection = aa*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
     // xsection = At*( 49.51*std::pow(sMand,-0.097) + 0.314*std::log(sMand)*std::log(sMand) );
     // xsection = At*( 38.4 + 0.85*std::abs(std::pow(log(sMand),1.47)) );
@@ -567,26 +569,26 @@
   else if(theParticle == theAProton) 
   {
-    xsection = At*( 21.70*std::pow(sMand,0.0808) + 98.39*std::pow(sMand,-0.4525));
+    xsection = aa*( 21.70*std::pow(sMand,0.0808) + 98.39*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == thePiPlus) 
   {
-    xsection = At*(13.63*std::pow(sMand,0.0808) + 27.56*std::pow(sMand,-0.4525));
+    xsection = aa*(13.63*std::pow(sMand,0.0808) + 27.56*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == thePiMinus) 
   {
     // xsection = At*( 55.2*std::pow(sMand,-0.255) + 0.346*std::log(sMand)*std::log(sMand) );
-    xsection = At*(13.63*std::pow(sMand,0.0808) + 36.02*std::pow(sMand,-0.4525));
+    xsection = aa*(13.63*std::pow(sMand,0.0808) + 36.02*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == theKPlus) 
   {
-    xsection = At*(11.82*std::pow(sMand,0.0808) + 8.15*std::pow(sMand,-0.4525));
+    xsection = aa*(11.82*std::pow(sMand,0.0808) + 8.15*std::pow(sMand,-0.4525));
   } 
   else if(theParticle == theKMinus) 
   {
-    xsection = At*(11.82*std::pow(sMand,0.0808) + 26.36*std::pow(sMand,-0.4525));
+    xsection = aa*(11.82*std::pow(sMand,0.0808) + 26.36*std::pow(sMand,-0.4525));
   }
   else  // as proton ??? 
   {
-    xsection = At*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
+    xsection = aa*(21.70*std::pow(sMand,0.0808) + 56.08*std::pow(sMand,-0.4525));
   } 
   xsection *= millibarn;
@@ -602,11 +604,10 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXscPDG(const G4DynamicParticle* aParticle, 
-                                                  const G4Element* anElement          )
-{
-  G4double At = anElement->GetN();  // number of nucleons 
-  G4double Zt = anElement->GetZ();  // number of protons
-
-
-  return GetHadronNucleonXscPDG( aParticle, At, Zt );
+                                                    const G4Element* anElement)
+{
+  G4int At = G4lrint(anElement->GetN());  // number of nucleons 
+  G4int Zt = G4lrint(anElement->GetZ());  // number of protons
+
+  return GetHadronNucleonXscPDG(aParticle, At, Zt);
 }
 
@@ -622,15 +623,17 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXscPDG(const G4DynamicParticle* aParticle, 
-                                                     G4double At,  G4double Zt )
+                                                    G4int At, G4int Zt)
 {
   G4double xsection;
 
-  G4double Nt = At-Zt;              // number of neutrons
-
-  if (Nt < 0.) Nt = 0.;  
-
+  G4int Nt = At-Zt;              // number of neutrons
+  if (Nt < 0) Nt = 0;
+  
+  G4double zz = Zt;
+  G4double aa = At;
+  G4double nn = Nt;
 
   G4double targ_mass = G4ParticleTable::GetParticleTable()->
-  GetIonTable()->GetIonMass( G4int(Zt+0.5) , G4int(At+0.5) );
+    GetIonTable()->GetIonMass(Zt, At);
 
   targ_mass = 0.939*GeV;  // ~mean neutron and proton ???
@@ -656,7 +659,7 @@
   if(theParticle == theNeutron) // proton-neutron fit 
   {
-    xsection = Zt*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection = zz*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
                           + 40.15*std::pow(sMand,-eta1) - 30.*std::pow(sMand,-eta2));
-    xsection  += Nt*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  += nn*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
 		      + 42.53*std::pow(sMand,-eta1) - 33.34*std::pow(sMand,-eta2)); // pp for nn
   } 
@@ -664,52 +667,52 @@
   {
       
-      xsection  = Zt*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
+      xsection  = zz*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
                           + 42.53*std::pow(sMand,-eta1) - 33.34*std::pow(sMand,-eta2));
 
-      xsection += Nt*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
+      xsection += nn*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
                           + 40.15*std::pow(sMand,-eta1) - 30.*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theAProton) 
   {
-    xsection  = Zt*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
                           + 42.53*std::pow(sMand,-eta1) + 33.34*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
                           + 40.15*std::pow(sMand,-eta1) + 30.*std::pow(sMand,-eta2));
   } 
   else if(theParticle == thePiPlus) 
   {
-    xsection  = At*( 20.86 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 20.86 + B*std::pow(std::log(sMand/s0),2.) 
                           + 19.24*std::pow(sMand,-eta1) - 6.03*std::pow(sMand,-eta2));
   } 
   else if(theParticle == thePiMinus) 
   {
-    xsection  = At*( 20.86 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 20.86 + B*std::pow(std::log(sMand/s0),2.) 
                           + 19.24*std::pow(sMand,-eta1) + 6.03*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theKPlus) 
   {
-    xsection  = Zt*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
                           + 7.14*std::pow(sMand,-eta1) - 13.45*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
                           + 5.17*std::pow(sMand,-eta1) - 7.23*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theKMinus) 
   {
-    xsection  = Zt*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
                           + 7.14*std::pow(sMand,-eta1) + 13.45*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
                           + 5.17*std::pow(sMand,-eta1) + 7.23*std::pow(sMand,-eta2));
   }
   else if(theParticle == theSMinus) 
   {
-    xsection  = At*( 35.20 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 35.20 + B*std::pow(std::log(sMand/s0),2.) 
                           - 199.*std::pow(sMand,-eta1) + 264.*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theGamma) // modify later on
   {
-    xsection  = At*( 0.0 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 0.0 + B*std::pow(std::log(sMand/s0),2.) 
                           + 0.032*std::pow(sMand,-eta1) - 0.0*std::pow(sMand,-eta2));
    
@@ -717,8 +720,8 @@
   else  // as proton ??? 
   {
-    xsection  = Zt*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
                           + 42.53*std::pow(sMand,-eta1) - 33.34*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
                           + 40.15*std::pow(sMand,-eta1) - 30.*std::pow(sMand,-eta2));
   } 
@@ -735,11 +738,10 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXscNS(const G4DynamicParticle* aParticle, 
-                                                  const G4Element* anElement          )
-{
-  G4double At = anElement->GetN();  // number of nucleons 
-  G4double Zt = anElement->GetZ();  // number of protons
-
-
-  return GetHadronNucleonXscNS( aParticle, At, Zt );
+                                                   const G4Element* anElement)
+{
+  G4int At = G4lrint(anElement->GetN());  // number of nucleons 
+  G4int Zt = G4lrint(anElement->GetZ());  // number of protons
+
+  return GetHadronNucleonXscNS(aParticle, At, Zt);
 }
 
@@ -754,5 +756,5 @@
 G4double 
 G4GlauberGribovCrossSection::GetHadronNucleonXscNS(const G4DynamicParticle* aParticle, 
-                                                     G4double At,  G4double Zt )
+                                                   G4int At, G4int Zt)
 {
   G4double xsection(0), Delta, A0, B0;
@@ -760,11 +762,13 @@
   G4double hnXsc(0);
 
-  G4double Nt = At-Zt;              // number of neutrons
-
-  if (Nt < 0.) Nt = 0.;  
-
+  G4int Nt = At-Zt;              // number of neutrons
+  if (Nt < 0) Nt = 0;  
+
+  G4double aa = At;
+  G4double zz = Zt;
+  G4double nn = Nt;
 
   G4double targ_mass = G4ParticleTable::GetParticleTable()->
-  GetIonTable()->GetIonMass( G4int(Zt+0.5) , G4int(At+0.5) );
+  GetIonTable()->GetIonMass(Zt, At);
 
   targ_mass = 0.939*GeV;  // ~mean neutron and proton ???
@@ -810,5 +814,5 @@
                      0.93827*0.93827,-0.165);        //  mb
       }
-      xsection *= Zt + Nt;
+      xsection *= zz + nn;
     }
     else
@@ -846,5 +850,5 @@
                  (std::pow(proj_momentum,2.50)+0.95);
       }
-      xsection = hpXsc*Zt + hnXsc*Nt;
+      xsection = hpXsc*zz + hnXsc*nn;
     }
   } 
@@ -867,5 +871,5 @@
                      0.93827*0.93827,-0.165);        //  mb
       }
-      xsection *= Zt + Nt;
+      xsection *= zz + nn;
     }
     else
@@ -903,5 +907,5 @@
                  (std::pow(proj_momentum,2.50)+0.95);
       }
-      xsection = hpXsc*Zt + hnXsc*Nt;
+      xsection = hpXsc*zz + hnXsc*nn;
       // xsection = hpXsc*(Zt + Nt);
       // xsection = hnXsc*(Zt + Nt);
@@ -921,14 +925,14 @@
     if( proj_momentum <= 1.0 )
     {
-      xsection  = Zt*(65.55 + 53.84/(proj_momentum+1.e-6)  );
+      xsection  = zz*(65.55 + 53.84/(proj_momentum+1.e-6)  );
     }
     else
     {
-      xsection  = Zt*( 41.1 + 77.2*std::pow( proj_momentum, -0.68) 
+      xsection  = zz*( 41.1 + 77.2*std::pow( proj_momentum, -0.68) 
                        + 0.293*logP*logP - 1.82*logP );
     }
-    if ( Nt > 0.)  
-    {
-      xsection += Nt*( 41.9 + 96.2*std::pow( proj_momentum, -0.99) - 0.154*logP);
+    if ( nn > 0.)  
+    {
+      xsection += nn*( 41.9 + 96.2*std::pow( proj_momentum, -0.99) - 0.154*logP);
     }
     else // H
@@ -987,5 +991,5 @@
       hnXsc = 10.6+2*std::log(proj_energy)+30*std::pow(proj_energy,-0.43); 
     }
-    xsection = hpXsc*Zt + hnXsc*Nt;
+    xsection = hpXsc*zz + hnXsc*nn;
   } 
   else if(theParticle == thePiMinus) 
@@ -1039,30 +1043,30 @@
       hpXsc = 10.6+2*std::log(proj_energy)+30*std::pow(proj_energy,-0.43); 
     }
-    xsection = hpXsc*Zt + hnXsc*Nt;
+    xsection = hpXsc*zz + hnXsc*nn;
   } 
   else if(theParticle == theKPlus) 
   {
-    xsection  = Zt*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
                           + 7.14*std::pow(sMand,-eta1) - 13.45*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
                           + 5.17*std::pow(sMand,-eta1) - 7.23*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theKMinus) 
   {
-    xsection  = Zt*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 17.91 + B*std::pow(std::log(sMand/s0),2.) 
                           + 7.14*std::pow(sMand,-eta1) + 13.45*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 17.87 + B*std::pow(std::log(sMand/s0),2.) 
                           + 5.17*std::pow(sMand,-eta1) + 7.23*std::pow(sMand,-eta2));
   }
   else if(theParticle == theSMinus) 
   {
-    xsection  = At*( 35.20 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 35.20 + B*std::pow(std::log(sMand/s0),2.) 
                           - 199.*std::pow(sMand,-eta1) + 264.*std::pow(sMand,-eta2));
   } 
   else if(theParticle == theGamma) // modify later on
   {
-    xsection  = At*( 0.0 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = aa*( 0.0 + B*std::pow(std::log(sMand/s0),2.) 
                           + 0.032*std::pow(sMand,-eta1) - 0.0*std::pow(sMand,-eta2));
    
@@ -1070,8 +1074,8 @@
   else  // as proton ??? 
   {
-    xsection  = Zt*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection  = zz*( 35.45 + B*std::pow(std::log(sMand/s0),2.) 
                           + 42.53*std::pow(sMand,-eta1) - 33.34*std::pow(sMand,-eta2));
 
-    xsection += Nt*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
+    xsection += nn*( 35.80 + B*std::pow(std::log(sMand/s0),2.) 
                           + 40.15*std::pow(sMand,-eta1) - 30.*std::pow(sMand,-eta2));
   } 
@@ -1087,11 +1091,10 @@
 G4double 
 G4GlauberGribovCrossSection::GetHNinelasticXsc(const G4DynamicParticle* aParticle, 
-                                                  const G4Element* anElement          )
-{
-  G4double At = anElement->GetN();  // number of nucleons 
-  G4double Zt = anElement->GetZ();  // number of protons
-
-
-  return GetHNinelasticXsc( aParticle, At, Zt );
+                                               const G4Element* anElement)
+{
+  G4int At = G4lrint(anElement->GetN());  // number of nucleons 
+  G4int Zt = G4lrint(anElement->GetZ());  // number of protons
+
+  return GetHNinelasticXsc(aParticle, At, Zt);
 }
 
@@ -1102,9 +1105,10 @@
 G4double 
 G4GlauberGribovCrossSection::GetHNinelasticXsc(const G4DynamicParticle* aParticle, 
-                                                     G4double At,  G4double Zt )
+                                                     G4int At,  G4int Zt)
 {
   G4ParticleDefinition* hadron = aParticle->GetDefinition();
-  G4double sumInelastic, Nt = At - Zt;
-  if(Nt < 0.) Nt = 0.;
+  G4double sumInelastic;
+  G4int Nt = At - Zt;
+  if(Nt < 0) Nt = 0;
   
   if( hadron == theKPlus )
@@ -1116,6 +1120,6 @@
     //sumInelastic  = Zt*GetHadronNucleonXscMK(aParticle, theProton);
     // sumInelastic += Nt*GetHadronNucleonXscMK(aParticle, theNeutron);    
-    sumInelastic  = Zt*GetHadronNucleonXscNS(aParticle, 1.0, 1.0);
-    sumInelastic += Nt*GetHadronNucleonXscNS(aParticle, 1.0, 0.0);    
+    sumInelastic  = G4double(Zt)*GetHadronNucleonXscNS(aParticle, 1, 1);
+    sumInelastic += G4double(Nt)*GetHadronNucleonXscNS(aParticle, 1, 0);    
   } 
   return sumInelastic;
@@ -1129,5 +1133,5 @@
 G4double 
 G4GlauberGribovCrossSection::GetHNinelasticXscVU(const G4DynamicParticle* aParticle, 
-                                                     G4double At,  G4double Zt )
+                                                 G4int At, G4int Zt)
 {
   G4int PDGcode    = aParticle->GetDefinition()->GetPDGEncoding();
@@ -1147,9 +1151,9 @@
   //G4cout<<"Plab = "<<Plab<<G4endl;
 
-  G4double NumberOfTargetProtons  = Zt; 
-  G4double NumberOfTargetNucleons = At;
+  G4double NumberOfTargetProtons = G4double(Zt); 
+  G4double NumberOfTargetNucleons = G4double(At);
   G4double NumberOfTargetNeutrons = NumberOfTargetNucleons - NumberOfTargetProtons;
 
-  if( NumberOfTargetNeutrons < 0.) NumberOfTargetNeutrons = 0.;
+  if(NumberOfTargetNeutrons < 0.0) NumberOfTargetNeutrons = 0.0;
 
   G4double Xtotal, Xelastic, Xinelastic;
@@ -1169,9 +1173,9 @@
                          0.169*sqrLogPlab - 1.85*LogPlab;
 
-       Xtotal          = ( NumberOfTargetProtons  * XtotPP +
-                           NumberOfTargetNeutrons * XtotPN  );
-
-       Xelastic        = ( NumberOfTargetProtons  * XelPP  +
-                           NumberOfTargetNeutrons * XelPN   );
+       Xtotal          = (NumberOfTargetProtons * XtotPP +
+                          NumberOfTargetNeutrons * XtotPN);
+
+       Xelastic        = (NumberOfTargetProtons * XelPP +
+                          NumberOfTargetNeutrons * XelPN);
   }
   else if( PDGcode ==  211 ) //------Projectile is PionPlus -------
@@ -1340,10 +1344,10 @@
 
 G4double 
-G4GlauberGribovCrossSection::GetNucleusRadius( const G4DynamicParticle* , 
-                                               const G4Element* anElement)
-{
-  G4double At       = anElement->GetN();
+G4GlauberGribovCrossSection::GetNucleusRadius(const G4DynamicParticle* , 
+                                              const G4Element* anElement)
+{
+  G4int At = G4lrint(anElement->GetN());
   G4double oneThird = 1.0/3.0;
-  G4double cubicrAt = std::pow (At, oneThird); 
+  G4double cubicrAt = std::pow(G4double(At), oneThird); 
 
   G4double R;  // = fRadiusConst*cubicrAt;
@@ -1377,9 +1381,9 @@
   G4double b3 = 4.;
 
-  if (At > 20.)   // 20.
+  if (At > 20)   // 20.
   {
     R *= ( a1 + b1*std::exp( -(At - meanA)/tauA1) ); 
   }
-  else if (At > 3.5)
+  else if (At > 3)
   {
     R *= ( 1.0 + b2*( 1. - std::exp( (At - meanA)/tauA2) ) ); 
@@ -1397,8 +1401,8 @@
 
 G4double 
-G4GlauberGribovCrossSection::GetNucleusRadius(G4double At)
+G4GlauberGribovCrossSection::GetNucleusRadius(G4int At)
 {
   G4double oneThird = 1.0/3.0;
-  G4double cubicrAt = std::pow (At, oneThird); 
+  G4double cubicrAt = std::pow(G4double(At), oneThird); 
 
   G4double R;  // = fRadiusConst*cubicrAt;
@@ -1424,11 +1428,11 @@
   G4double tauA  = 20.; 
 
-  if (At > 20.)   // 20.
-  {
-    R *= ( 0.8 + 0.2*std::exp( -(At - meanA)/tauA) ); 
+  if (At > 20)   // 20.
+  {
+    R *= ( 0.8 + 0.2*std::exp( -(G4double(At) - meanA)/tauA) ); 
   }
   else
   {
-    R *= ( 1.0 + 0.1*( 1. - std::exp( (At - meanA)/tauA) ) ); 
+    R *= ( 1.0 + 0.1*( 1. - std::exp( (G4double(At) - meanA)/tauA) ) ); 
   }
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1340)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 //
@@ -1230,10 +1230,10 @@
       G4IsotopeVector* isoVector = element->GetIsotopeVector();
       G4double* abundVector = element->GetRelativeAbundanceVector();
-      G4double ZZ;
-      G4double AA;
+      G4int ZZ;
+      G4int AA;
 
       for (G4int i = 0; i < nIso; i++) {
-        ZZ = G4double( (*isoVector)[i]->GetZ() );
-        AA = G4double( (*isoVector)[i]->GetN() );
+        ZZ = (*isoVector)[i]->GetZ();
+        AA = (*isoVector)[i]->GetN();
         CalcScatteringCrossSections(particle, ZZ, AA);
         cross_section += siginelastic*abundVector[i];
@@ -1241,6 +1241,8 @@
       siginelastic = cross_section;
 
-    } else { 
-      CalcScatteringCrossSections(particle, element->GetZ(), element->GetN());
+    } else {
+      G4int ZZ = G4lrint(element->GetZ());
+      G4int AA = G4lrint(element->GetN());
+      CalcScatteringCrossSections(particle, ZZ, AA);
     }
   }
@@ -1249,7 +1251,7 @@
 
 
-G4double G4HadronCrossSections::GetInelasticCrossSection(
-                          const G4DynamicParticle* particle,
-                          G4double ZZ, G4double AA)
+G4double
+G4HadronCrossSections::GetInelasticCrossSection(const G4DynamicParticle* particle,
+                                                G4int ZZ, G4int AA)
 {
   prevElement = 0; // force new cross section calculation for next call of
@@ -1274,10 +1276,10 @@
       G4IsotopeVector* isoVector = element->GetIsotopeVector();
       G4double* abundVector = element->GetRelativeAbundanceVector();
-      G4double ZZ;
-      G4double AA;
+      G4int ZZ;
+      G4int AA;
 
       for (G4int i = 0; i < nIso; i++) {
-        ZZ = G4double( (*isoVector)[i]->GetZ() );
-        AA = G4double( (*isoVector)[i]->GetN() );
+        ZZ = (*isoVector)[i]->GetZ();
+        AA = (*isoVector)[i]->GetN();
         CalcScatteringCrossSections(particle, ZZ, AA);
         cross_section += sigelastic*abundVector[i];
@@ -1285,6 +1287,8 @@
       sigelastic = cross_section;
 
-    } else { 
-      CalcScatteringCrossSections(particle, element->GetZ(), element->GetN());
+    } else {
+      G4int ZZ = G4lrint(element->GetZ());
+      G4int AA = G4lrint(element->GetN());
+      CalcScatteringCrossSections(particle, ZZ, AA);
     }
   }
@@ -1293,7 +1297,7 @@
 
 
-G4double G4HadronCrossSections::GetElasticCrossSection(
-                          const G4DynamicParticle* particle,
-                          G4double ZZ, G4double AA)
+G4double
+G4HadronCrossSections::GetElasticCrossSection(const G4DynamicParticle* particle,
+                                              G4int ZZ, G4int AA)
 {
   prevElement = 0; // force new cross section calculation for next call of
@@ -1312,5 +1316,5 @@
 G4HadronCrossSections::CalcScatteringCrossSections(
                           const G4DynamicParticle* aParticle,
-                          G4double ZZ, G4double AA)
+                          G4int ZZ, G4int AA)
 {
    G4double sigel, sigin, sigtot;
@@ -1583,5 +1587,5 @@
 G4HadronCrossSections::GetCaptureCrossSection(
                           const G4DynamicParticle* aParticle,
-                          G4double ZZ, G4double /*AA*/)
+                          G4int ZZ, G4int /*AA*/)
 {
    if (GetParticleCode(aParticle) != 16)  { return 0.; }
@@ -1596,5 +1600,5 @@
    }
 
-   G4int izno = static_cast<G4int> (ZZ + 0.01);
+   G4int izno = ZZ;
    if (izno > 100) izno = 100;      // Not in GHESIG
    izno = izno - 1;      // For array indexing
@@ -1609,18 +1613,9 @@
 G4HadronCrossSections::GetFissionCrossSection(
                           const G4DynamicParticle* aParticle,
-                          G4double ZZ, G4double AA)
+                          G4int ZZ, G4int AA)
 {
-   if (AA < 230.) return 0;
+   if (AA < 230) return 0;
 
    G4double ek = aParticle->GetKineticEnergy()/GeV;      
-
-   //   G4int i = NFISS;
-   //   for (G4int ii = 1; i <= NFISS; i++) {
-   //      if (ek < ekfiss[ii - 1]) {
-   //         i = ii;
-   //         break;
-   //      }
-   //   }
-   //   i = i - 1;      // For array indexing
 
    G4int ie1 = 0;
@@ -1638,11 +1633,11 @@
    G4int j = 4;
    if (ek <= 0.01) {
-      if (ZZ == 92. && std::abs(AA - 233.) < 0.5) j = 1;
-      else if (ZZ == 92. && std::abs(AA - 235.) < 0.5) j = 2;
-      else if (ZZ == 94. && std::abs(AA - 239.) < 0.5) j = 3;
+      if (ZZ == 92 && AA == 233) j = 1;
+      else if (ZZ == 92 && AA == 235) j = 2;
+      else if (ZZ == 94 && AA == 239) j = 3;
    }
    G4double z43ba;
    if (j == 4) {
-      z43ba = std::pow(ZZ, 4./3.)/AA;
+      z43ba = std::pow(G4double(ZZ), 4./3.)/G4double(AA);
       z43ba = std::max(-67. + 38.7*z43ba, 0.);
    }
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc	(revision 1340)
@@ -33,8 +33,5 @@
 #include "G4IonTable.hh"
 #include "G4ParticleDefinition.hh"
-
-//////////////////////////////////////////////////////////////////////////////////////
-//
-//
+#include "G4HadTmpUtil.hh"
 
 
@@ -80,6 +77,5 @@
 
 G4HadronNucleonXsc::~G4HadronNucleonXsc()
-{
-}
+{}
 
 
@@ -91,18 +87,19 @@
 G4bool 
 G4HadronNucleonXsc::IsApplicable(const G4DynamicParticle* aDP, 
-					  const G4Element*  anElement)
+                                 const G4Element* anElement)
 {
-  return IsZAApplicable(aDP, anElement->GetZ(), anElement->GetN());
+  G4int Z = G4lrint(anElement->GetZ());
+  G4int A = G4lrint(anElement->GetN());
+  return IsIsoApplicable(aDP, Z, A);
 } 
 
 ////////////////////////////////////////////////////////////////////////////////////////
 //
-//
 
 G4bool 
-G4HadronNucleonXsc::IsZAApplicable(const G4DynamicParticle* aDP, 
-					    G4double Z, G4double)
+G4HadronNucleonXsc::IsIsoApplicable(const G4DynamicParticle* aDP, 
+                                    G4int Z, G4int)
 {
-  G4bool applicable      = false;
+  G4bool applicable = false;
   // G4int baryonNumber     = aDP->GetDefinition()->GetBaryonNumber();
   G4double kineticEnergy = aDP->GetKineticEnergy();
@@ -111,5 +108,5 @@
  
   if ( ( kineticEnergy  >= fLowerLimit &&
-         Z > 1.5 &&      // >=  He
+         Z > 1 &&      // >=  He
        ( theParticle == theAProton   ||
          theParticle == theGamma     ||
@@ -119,5 +116,5 @@
 
        ( kineticEnergy  >= 0.1*fLowerLimit &&
-         Z > 1.5 &&      // >=  He
+         Z > 1 &&      // >=  He
        ( theParticle == theProton    ||
          theParticle == theNeutron   ||   
@@ -127,6 +124,4 @@
   return applicable;
 }
-
-
 
 
@@ -210,7 +205,4 @@
 
 
-
-
-
 /////////////////////////////////////////////////////////////////////////////////////
 //
@@ -242,5 +234,4 @@
   G4double B    = 0.308;
 
-
   const G4ParticleDefinition* theParticle = aParticle->GetDefinition();
 
@@ -249,5 +240,4 @@
   G4bool neutron = (nucleon == theNeutron);
   
-
   if(theParticle == theNeutron) // proton-neutron fit 
   {
@@ -358,5 +348,4 @@
   return xsection;
 }
-
 
 
@@ -758,6 +747,4 @@
   G4bool neutron = (nucleon == theNeutron);
 
-
-
    
   if( absPDGcode > 1000 && pORn )  //------Projectile is baryon -
